/*-------------------------------------------------------------
 *  Copyright (c) 2011, MSS ComBlock. All rights reserved.
 *
 * 	Filename: RF.h
 *  Last modified: 6/8/11
 *  Authors:
 *  	Alain Zarembowitch / MSS ComBlock
 *  Version: 1.0
 *  Inheritance: N/A
 *  Description: RF components driver, specific for COM-3505 transceiver
 -------------------------------------------------------------*/
#ifndef RF_H_
#define RF_H_


/*-------- change this section according to the schematics ----------------------------------------*/
// MAX2829 ICs
#define PIN_XCVR_DIN_H() FIO2SET = 0x00000080;    	// port2[7]
#define PIN_XCVR_SCLK_H() FIO2SET = 0x00000100;    	// port2[8]
#define PIN_XCVR1_CSB_H() FIO0SET = 0x00000001;    	// port0[0]
#define PIN_XCVR1_RXHP_H() FIO2SET = 0x00000200;    // port2[9]
#define PIN_XCVR1_SHDNB_H() FIO0SET = 0x00000040;   // port0[6]
#define PIN_XCVR1_RXENA_H() FIO0SET = 0x00000100;   // port0[8]
#define PIN_XCVR1_TXENA_H() FIO0SET = 0x00000400;   // port0[10]
#define PIN_XCVR1_SHDNB_H() FIO0SET = 0x00000040;   // port0[6]
#define PIN_XCVR2_CSB_H() FIO0SET = 0x00000002;    	// port0[1]
#define PIN_XCVR2_RXHP_H() FIO2SET = 0x00000400;    // port2[10]
#define PIN_XCVR2_SHDNB_H() FIO0SET = 0x00000080;   // port0[7]
#define PIN_XCVR2_RXENA_H() FIO0SET = 0x00000200;   // port0[9]
#define PIN_XCVR2_TXENA_H() FIO0SET = 0x00000800;   // port0[11]

#define PIN_XCVR_DIN_L() FIO2CLR = 0x00000080;    	// port2[7]
#define PIN_XCVR_SCLK_L() FIO2CLR = 0x00000100;    	// port2[8]
#define PIN_XCVR1_CSB_L() FIO0CLR = 0x00000001;    	// port0[0]
#define PIN_XCVR1_RXHP_L() FIO2CLR = 0x00000200;    // port2[9]
#define PIN_XCVR1_SHDNB_L() FIO0CLR = 0x00000040;   // port0[6]
#define PIN_XCVR1_RXENA_L() FIO0CLR = 0x00000100;   // port0[8]
#define PIN_XCVR1_TXENA_L() FIO0CLR = 0x00000400;   // port0[10]
#define PIN_XCVR2_CSB_L() FIO0CLR = 0x00000002;    	// port0[1]
#define PIN_XCVR2_RXHP_L() FIO2CLR = 0x00000400;    // port2[10]
#define PIN_XCVR2_SHDNB_L() FIO0CLR = 0x00000080;   // port0[7]
#define PIN_XCVR2_RXENA_L() FIO0CLR = 0x00000200;   // port0[9]
#define PIN_XCVR2_TXENA_L() FIO0CLR = 0x00000800;   // port0[11]

// SKYWORKS front-end module
#define PIN_PU0A_H()  FIO1SET = 0x00000010;	// port1[4]
#define PIN_PU0G_H()  FIO1SET = 0x00000100;	// port1[8]
#define PIN_PU1A_H()  FIO1SET = 0x00000200;	// port1[9]
#define PIN_PU1G_H()  FIO1SET = 0x00000400;	// port1[10]
#define PIN_TX0AG_H()  FIO1SET = 0x00004000;	// port1[14]
#define PIN_RX0AG_H()  FIO1SET = 0x00008000;	// port1[15]
#define PIN_TX1AG_H()  FIO1SET = 0x00040000;	// port1[18]
#define PIN_RX1AG_H()  FIO1SET = 0x00080000;	// port1[19]

#define PIN_PU0A_L()  FIO1CLR = 0x00000010;	// port1[4]
#define PIN_PU0G_L()  FIO1CLR = 0x00000100;	// port1[8]
#define PIN_PU1A_L()  FIO1CLR = 0x00000200;	// port1[9]
#define PIN_PU1G_L()  FIO1CLR = 0x00000400;	// port1[10]
#define PIN_TX0AG_L()  FIO1CLR = 0x00004000;	// port1[14]
#define PIN_RX0AG_L()  FIO1CLR = 0x00008000;	// port1[15]
#define PIN_TX1AG_L()  FIO1CLR = 0x00040000;	// port1[18]
#define PIN_RX1AG_L()  FIO1CLR = 0x00080000;	// port1[19]

// LNAs
#define PIN_LNA1_24_H()  FIO1SET = 0x00100000;	// port1[20]
#define PIN_LNA1_52_H()  FIO1SET = 0x00800000;	// port1[23]
#define PIN_LNA2_24_H()  FIO1SET = 0x01000000;	// port1[24]
#define PIN_LNA2_52_H()  FIO1SET = 0x02000000;	// port1[25]

#define PIN_LNA1_24_L()  FIO1CLR = 0x00100000;	// port1[20]
#define PIN_LNA1_52_L()  FIO1CLR = 0x00800000;	// port1[23]
#define PIN_LNA2_24_L()  FIO1CLR = 0x01000000;	// port1[24]
#define PIN_LNA2_52_L()  FIO1CLR = 0x02000000;	// port1[25]



/*-------- end of schematics-dependent code ----------------------------------------*/
extern void max2829_init(int);
extern void max2829_reg(int, int, int);
extern long rf_synth_lock_detect(void);
extern unsigned long get_freq(long );
extern void program_tuner_pll(int);
extern void bandwidth(int);
extern void setRxGain(int,int);
extern void setTxGain(int);
extern void power_up_down1(void);
extern void power_up_down2(void);
extern void rx_txn(void);
extern void DAC_init(void);
extern void DAC_poll(int, int);
extern void DAC(long);
extern void analogTP_poll(void);
extern void RxAGC_poll(int);
extern void ADC_init(void);
extern void ADC_poll(void);
//extern void ADC(int);

extern int rx_txn1, rx_txn2;	// detect changes in RX_TXn
extern unsigned long rx1_rssi;	// read via AD0[5]
extern unsigned long rx2_rssi;	// read via AD0[5]
extern unsigned long rx1_agc;	// read via AD0[5]
extern unsigned long rx2_agc;	// read via AD0[5]
extern unsigned long tx1_gain_ctrl;	// read via AD0[5]
extern unsigned long tx2_gain_ctrl;	// read via AD0[5]
extern unsigned long tx1_power_det;	// read via AD0[5]
extern unsigned long tx2_power_det;	// read via AD0[5]

#endif /* RF_H_ */
